using System;
using System.Collections.Generic;

/// @author  Vesa Lappalainen
/// @version 27.10.2012
/// <summary>
/// Esimerkkejä olioista
/// </summary>
public class ElaimetPerimalla
{
    /// <summary>
    /// Tutkitaan olioiden käyttäytymistä
    /// </summary>
    public static void Main()
    {
        Kissa miuku = new Kissa("Miuku", 900);
        Kissa mirri = new Kissa("Mirri", 19000);
        Koira musti = new Koira("Musti", 2700);

        miuku.Aantele();
        mirri.Aantele();
        musti.Aantele();
        
        Console.WriteLine(miuku); // kutsuu oikeasti miuku.ToString();
        Console.WriteLine(miuku); // kutsuu oikeasti miuku.ToString();
        Console.WriteLine(musti); // kutsuu oikeasti miuku.ToString();
        
        List<Elain> elaimet = new List<Elain>();
        elaimet.Add(mirri);
        elaimet.Add(miuku);
        elaimet.Add(musti);
        
        foreach (Elain elain in elaimet)
            elain.Aantele();
        
    }
}


public class Elain 
{
    private readonly string nimi;   // attribuutti
    private readonly double paino;

    protected Elain(string nimi, double paino)  // Muodostaja
    {
        this.nimi = nimi;
        this.paino = paino;
    }


    public virtual void Aantele()  // metodi
    {
        Console.WriteLine("???");
    }

    
    /// <summary>
    /// Elain tiedot merkkijonona
    /// </summary>
    /// <returns>Kissan tiedot merkkijonona</returns>
    public override string ToString()
    {
        return nimi + " " + paino;
    }
}

public class Kissa: Elain // luokka 
{
    private readonly double hannanPituus = 10;
    public Kissa(string nimi, double paino): base(nimi, paino)  // Muodostaja
    {
    }


    public override void Aantele()  // metodi
    {
        Console.WriteLine("Miau, minulla on " + hannanPituus + " cm häntä");
    }

    
    public override string ToString()
    {
        return base.ToString() + " " + hannanPituus + " cm häntä";
    }

}


public class Koira: Elain // luokka 
{
    public Koira(string nimi, double paino): base(nimi, paino)  // Muodostaja
    {
    }


    public override void Aantele()  // metodi
    {
        Console.WriteLine("Hau hau");
    }
}